 /*	  First version:  02/05/2016, Yury Vilk. 

   Usage:

	%file_watcher(file_name=&infolder_dir.files_done.ok
		 					 ,wait_time_min=3
							 ,wait_time_max=30
							);

	%file_watcher(file_name=&infolder_dir.files_done1.ok
		 					 ,wait_time_min=3
							 ,wait_time_max=30
							);

	*/
 
%MACRO file_watcher(file_name=
									 ,wait_time_min=3
					                 ,wait_time_max=3600
	                                 ,time_unit=1
                                     ,silent_flag=0);

 %IF   &silent_flag.=0	 %THEN %DO;
  %PUT;
   %PUT -----   Start of the macro file_watcher;
   %PUT;
					   %END;

	%GLOBAL _fileexist_flag;
	%LOCAL current_date_time;

	%LET _fileexist_flag=0;
		 DATA  _NULL_;
		   start_time=DATETIME();
		  DO  UNTIL(done);
		   CALL SLEEP(&wait_time_min.,&time_unit.);
 		     fileexist_flag=fileexist("&file_name.");
			 cur_time=DATETIME();
			 time_passed=cur_time-start_time;
			 done=(fileexist_flag OR time_passed> &wait_time_max.*&time_unit.); 		
		   END;
		    CALL SYMPUT("_fileexist_flag",PUT((fileexist_flag>0),1.) );
			CALL SYMPUT("current_date_time",STRIP(PUT(cur_time,DATETIME21.)));
		 RUN;

		 %IF   &silent_flag.=0	 %THEN %DO;
		        %PUT  file_name=&file_name.; 
				%PUT  _fileexist_flag=&_fileexist_flag.; 
		       	%PUT  current_date_time=&current_date_time.;
                  
  %PUT;
   %PUT -----   End of the macro file_watcher;
   %PUT;
														%END;
	%MEND /* file_watcher*/;
